; 21  , 84  (RC 45k/120pkF)
;
	list      p=16F84A            ; list directive to define processor
	#include <p16F84A.inc>        ; processor specific variable definitions

	__CONFIG   _CP_OFF & _WDT_ON & _PWRTE_ON & _RC_OSC

	CBLOCK	0x0C
		TEMP
		COUNT
		BYTE1
		BYTE2
		BYTE3
		BYTE4
		NUMDIV
		COUNTER1
	ENDC
;---------------------------
#define		CSQ		PORTA,0
#define		PTT		PORTA,1
;---------------------------
#define 	CLOCK1	PORTB,0
#define		DATA1	PORTB,1
#define		ENB1	PORTB,2
#define 	CLOCK2	PORTB,3
#define		DATA2	PORTB,4
#define		ENB2	PORTB,5
;---------------------------
		ORG		0H
		GOTO	START
		ORG		4H
		RETFIE
;---------------------------
KTABLE	ADDWF	PCL					;  
	DT		.16,  .225, .32,   .91	; 439.9625 (12500)
;---------------------------
TXDATA		ADDWF    PCL,F
			DT B'01000010', B'11011000', B'10100000'
;---------------------------------------------------------
SENDPLL	CLRF	PORTB		; 4   MC145159
;
		MOVF	BYTE1,W
		CALL	SNDBYTE
		MOVF	BYTE2,W
		CALL	SNDBYTE
		MOVF	BYTE3,W
		CALL	SNDBYTE
		MOVF	BYTE4,W
		CALL	SNDBYTE
		BCF		CLOCK1
;
		BSF		ENB1
		NOP
		NOP
		NOP
		BCF		ENB1
		RETURN
;
SNDBYTE	MOVWF	TEMP		;    PLL
		MOVLW	8
		MOVWF	COUNT
LPBYTE	BCF		CLOCK1	;   0
		RLF		TEMP,F
		BTFSS	STATUS,C
		BCF		DATA1
		BTFSC	STATUS,C
		BSF		DATA1	;  
		NOP
		BSF		CLOCK1	;   1
		NOP
		NOP
		DECFSZ	COUNT
		GOTO	LPBYTE
		RETURN
;---------------------------------------------------------
			;  W -     
TOPLL	MOVWF	NUMDIV	;  4 ,    R,N,A 
		CALL	KTABLE
		MOVWF	BYTE1
;
		INCF	NUMDIV,F
		MOVF	NUMDIV,W
		CALL	KTABLE
		MOVWF	BYTE2
;
		INCF	NUMDIV,F
		MOVF	NUMDIV,W
		CALL	KTABLE
		MOVWF	BYTE3
;
		INCF	NUMDIV,F
		MOVF	NUMDIV,W
		CALL	KTABLE
		MOVWF	BYTE4
;
		CALL	SENDPLL
		RETURN
;---------------------------------------------------------
DELAY	MOVLW	.100			;  84 * 3 * 100 = 25200 
		MOVWF	COUNTER1
CYCD	CLRWDT
		INCFSZ	COUNTER1
		 GOTO	CYCD
		RETURN
;---------------------------------------------------------
ONPTT	CALL	DELAY
		BTFSS	CSQ
		 RETURN
		BTFSC	PTT
		 RETURN
		BSF		PTT
		RETURN
;---------------------------------------------------------
OFFPTT	CALL	DELAY
		BTFSC	CSQ
		 RETURN
		BTFSS	PTT
		 RETURN
		BCF		PTT
		RETURN
;---   145.725----------------------------------
SENDBIT		BSF		CLOCK2
			NOP
			NOP
			RLF		TEMP,F
			BTFSS	STATUS,C
			 BCF	DATA2
			BTFSC	STATUS,C
			 BSF	DATA2
			NOP
			NOP
			NOP
			BCF		CLOCK2
			RETURN
;-----------------  TX  ------------------
SEND_TX		MOVLW	.8			;   
			MOVWF	COUNT
			MOVLW	HIGH TXDATA	;  AN556E
			MOVWF	PCLATH
			MOVLW	0
			CALL	TXDATA
			MOVWF	TEMP
LOOP_0T		CALL	SENDBIT	
			DECFSZ	COUNT,F
			 GOTO	LOOP_0T
;
			MOVLW	.8			;   
			MOVWF	COUNT
			MOVLW	HIGH TXDATA	;  AN556E
			MOVWF	PCLATH
			MOVLW	1
			CALL	TXDATA
			MOVWF	TEMP
LOOP_1T		CALL	SENDBIT	
			DECFSZ	COUNT,F
			 GOTO	LOOP_1T
;
			MOVLW	.3			;   
			MOVWF	COUNT
			MOVLW	HIGH TXDATA	;  AN556E
			MOVWF	PCLATH
			MOVLW	2
			CALL	TXDATA
			MOVWF	TEMP
LOOP_2T		CALL	SENDBIT	
			DECFSZ	COUNT,F
			 GOTO	LOOP_2T
			NOP
			NOP
			NOP
			BSF		ENB2		;  
			NOP
			NOP
			BCF		ENB2
			RETURN
;---------------------------------------------------------
START	
		BANKSEL	TRISA
		MOVLW	B'00011101'
		MOVWF	TRISA			; 1 -  PTT
		CLRF	TRISB			;    
		BANKSEL	PORTA
;
		MOVLW	0
		CALL	TOPLL			;  MC145159
;
		CALL	SEND_TX			;  150811
;
CYCLE	CLRWDT
		BTFSS	CSQ				;  PTT on/off
		 CALL	OFFPTT
		BTFSC	CSQ
		 CALL	ONPTT
;
		GOTO	CYCLE
;---------------------------------------------------------
	org 0x2100	 						; Initialize EEPROM Data
	DE	"EW1LN   MINSK   2004    +375-29-7505835   "
END




